;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;  SELOR - Servidor de Emails Livre Orientado a Regras                             
;  Programado por Lucas Priori                                                     
;                                                                                  
;  Copyright (c) 2013,2014 Lucas Priori                                            
;                                                                                  
;  Permission is hereby granted, free of charge, to any person obtaining a copy    
;  of this software and associated documentation files (the "Software"), to deal   
;  in the Software without restriction, including without limitation the rights    
;  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell       
;  copies of the Software, and to permit persons to whom the Software is           
;  furnished to do so, subject to the following conditions:                        
;                                                                                  
;  The above copyright notice and this permission notice shall be included in      
;  all copies or substantial portions of the Software.                             
;                                                                                  
;  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      
;  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        
;  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     
;  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          
;  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   
;  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN       
;  THE SOFTWARE.                                                                   
;                                                                                  



;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

[BITS 64]
;=======================================================================

%define TAM_str_itoa 32
%define DOSD_ip r10
%define DOSD_timestamp r10 + 4
%define DOSD_mem r10 + 8
%define DOSD_fim_mem r10 + 16
%define DOSD_atual_posi r10 + 24
%define DOSD_intervalo r10 + 32
%define DOSD_num_ocorr r10 + 36
;---



global pular_carac
global str_arruma_crlf
global selor_strncpy
global special_cp
global selor_strncat
global selor_superstrncpy
global cmp_str
global cmp_str_vars
global base64_decod
global base64_cod
global selor_segcp
global t_inject_helo
global conv_crlf
global cpl
global itoa
global tmasc
global dosd
;-- Variaveis globais --
global base_val_email
global cpl_orig
global cpl_dest
global cpl_tambuffer
global cpl_tamlinha
global texto_itoa

;---
[SECTION .data]

                                ;   0 1 2 3 4 5 6 7 8 9 A B C D E F    
base_val_helo			db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 0
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 1
				db  1,0,0,0,0,1,1,0,0,0,0,1,1,1,1,0 ; 2
				db  1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0 ; 3
				db  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ; 4
				db  1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,1 ; 5
				db  0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ; 6
				db  1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0 ; 7
				db  0,1,0,0,0,0,0,1,0,1,0,0,0,1,0,0 ; 8
				db  0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0 ; 9
				db  0,1,0,0,0,0,0,1,0,1,0,0,0,1,0,0 ; A
				db  0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0 ; B
				db  0,1,0,1,0,0,0,1,0,1,0,0,0,1,0,0 ; C
				db  0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0 ; D
				db  0,1,0,0,0,0,0,1,0,1,0,0,0,1,0,0 ; E
				db  0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0 ; F


                                ;   0 1 2 3 4 5 6 7 8 9 A B C D E F    
base_val_email			db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 0
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 1
				db  0,0,0,0,0,1,1,0,0,0,0,1,1,1,1,0 ; 2
				db  1,1,1,1,1,1,1,1,1,1,0,0,0,1,0,0 ; 3
				db  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ; 4
				db  1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1 ; 5
				db  0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1 ; 6
				db  1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0 ; 7
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 8
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 9
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; A
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; B
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; C
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; D
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; E
				db  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; F
;---
                                ;    0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F    
base64_reversa                  db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; 0
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; 1
				db  00,00,00,00,00,00,00,00,00,00,00,62,00,00,00,63 ; 2
				db  52,53,54,55,56,57,58,59,60,61,00,00,00,00,00,00 ; 3
				db  00,00,01,02,03,04,05,06,07,08,09,10,11,12,13,14 ; 4
				db  15,16,17,18,19,20,21,22,23,24,25,00,00,00,00,00 ; 5
				db  00,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40 ; 6
				db  41,42,43,44,45,46,47,48,49,50,51,00,00,00,00,00 ; 7
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; 8
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; 9
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; A
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; B
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; C
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; D
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; E
				db  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00 ; F
;---
base64_tab			db 'A','B','C','D','E','F','G','H','I','J','K','L','M',
				db 'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
				db 'a','b','c','d','e','f','g','h','i','j','k','l','m',
				db 'n','o','p','q','r','s','t','u','v','w','x','y','z',
				db '0','1','2','3','4','5','6','7','8','9','+','/', 0
;---
cpl_orig			dd  0
cpl_dest			dd  0
cpl_tambuffer			dd  0
cpl_tamlinha			dd  0
;---
texto_itoa			times TAM_str_itoa+1 db 0
;=======================================================================
[SECTION .text]


; Sequencia de parametros que o gcc passa para as funcoes:
; RDI, RSI, RDX, RCX, R8 e R9

; Nao precisam ser salvos na pilha:
; RAX, R10 e R11

;======================================================= 
; Funcao para pular uma sequencia de caracteres          
; Retornos:                                              
; RAX -> Ponteiro da posicao do primeiro carac diferente 
; char *pular_carac(char *string, int carac)
pular_carac:			mov  ax, si
				shl  ax, 8
				mov  rsi, rdi
.Volta:				lodsb
				cmp  al, ah
				je   .Volta
				dec  rsi
				mov  rax, rsi
				ret
;======================================================= 
; Funcao para trocar o \r e \n para ' '                  
; void str_arruma_crlf(char *string);
str_arruma_crlf:		dec  rdi
.Volta:				inc  rdi
				mov  al, [rdi]
				test al, al
				jz   .Fim
				cmp  al, 13
				je   .Trocar
				cmp  al, 10
				je   .Trocar
				jmp  .Volta
.Trocar:			mov  [rdi], byte ' '
				jmp  .Volta
.Fim:				ret
;======================================================= 
; Funcao semelhante a strncpy, porem, retorna o numero   
; de bytes copiados, pra quando encontra ZERO e tem     
; protecao contra buffer overflow                        
; entradas nos regs: (char *destino[RDI], char *origem[RSI], unsigned int tam_str[RDX])
; unsigned int selor_strncpy(char *destino, char *origem, unsigned int tam_str)
selor_strncpy:			mov  rcx, rdx
				dec  rcx              ; Reversando um espaco para o ZERO final de string
				mov  r10, rsi
.Volta:				lodsb
				stosb
				test al, 0FFh
				jz   .Fim
				loop .Volta
				inc  rsi
.Fim:				mov  [rdi], byte 0
				mov  rax, rsi
				sub  rax, r10
				dec  rax              ; RAX = Bytes copiados
				ret
;======================================================= 
; Funcao semelhante a strncpy, porem, retorna o numero   
; de bytes copiados, pra quando encontra ZERO, protecao 
; contra buffer_overflow e converte \n em codig. 10      
; entradas nos regs: (char *destino [RDI], char *origem [RSI], unsigned int tam_str [RDX])
; unsigned int special_cp(char *destino, char *origem, unsigned int tam_str)
special_cp:			mov  rcx, rdx
				dec  rcx              ; Reversando um espaco para o ZERO final de string
				mov  r10, rdi
.Volta:				lodsb
				cmp  al, 92           ; 92 --> '\'
				je   .Converter
.Copiar:			stosb
				test al, 0FFh
				jz   .Fim
				loop .Volta
.Fim:				mov  [rdi], byte 0
				mov  rax, rdi
				sub  rax, r10
				dec  rax              ; RAX = Bytes copiados
				ret
.Converter:			lodsb
				cmp  al, 'n'
				je   .Trocar_n
				cmp  al, 't'
				jne  .Copiar
				mov  al, 9           ; 10 = TAB
				jmp  .Copiar
.Trocar_n:			mov  al, 10          ; 10 = Nova linha
				jmp  .Copiar
;======================================================= 
; Funcao para juntar varias strings em uma so            
; O ultimo parametro passado deve ser NULL               
; Retornos:                                              
; RAX = Tamanho da nova string                           
;(char *destino[RDI], unsigned int tam_str[RSI], [RDX], [RCX], [R8], [R9], [... pilha])
;unsigned int selor_superstrncpy(char *destino, unsigned int tam_str, ...);    OBS: O ultmo parametro DEVE ser sempre NULL
selor_superstrncpy:		mov  r11, rdi      ; Salvando posicao para calcular tamanho da nova string
				mov  r10, rcx      ; R10 = param 2
				mov  rcx, rsi      ; RCX = tam_str
				xor  rax, rax
				test rdx, rdx
				jz   .Fim
				mov  rsi, rdx
				call .Cp
				test r10, r10
				jz   .Fim
				mov  rsi, r10
				call .Cp
				test r8, r8
				jz   .Fim
				mov  rsi, r8
				call .Cp
				test r9, r9
				jz   .Fim
				mov  rsi, r9
				call .Cp
				mov  r8, rsp
.Prox_param:			add  r8, 8         ; Prox parametro
				mov  rsi, [r8]
				test rsi, rsi
				jz   .Fim
.Cp2:				lodsb
				test al, al
				jz  .Prox_param
				stosb
				loop .Cp2
				mov  [rdi], byte 0
				mov  rax, rdi
				sub  rax, r11
				ret
.Cp:				lodsb
				test al, al
				jz  .Ret           ; Fim apenas desta copia. Ele vai continuar aqui dentro
				stosb
				loop .Cp
				add  rsp, 8        ; Tirando o ret da ultima chamada .Cp para sair da funcoo no proximo ret
.Fim:				mov  [rdi], byte 0
				mov  rax, rdi
				sub  rax, r11
.Ret:				ret
;======================================================= 
; Funcao semelhante a strncat, porem, retorna o numero   
; de bytes da nova string, pra quando encontra ZERO e   
; tem protecao contra buffer overflow                    
;(char *destino[RDI], char *origem[RSI], unsigned int tam_str[RDX])
; unsigned int selor_strncat(char *destino, char *origem, unsigned int tam_str);
selor_strncat:			mov  rcx, rdx
				dec  rcx              ; Reversando um espaco para o ZERO final de string
				mov  r10, rdi
				xor  al, al
				repne scasb
				test rcx, rcx
				jz   .Fim
				dec  rdi
				inc  rcx
.Volta:				lodsb
				test al, 0FFh
				jz   .Fim
				stosb
				loop .Volta
.Fim:				mov  [rdi], byte 0
				mov  rax, rdi
				sub  rax, r10
				ret
;======================================================= 
; Funcao para comparar duas strings desconciderando      
; a diferena entre maisculas e minsculas              
; Retornos:                                              
; RAX = 0 -> Strings sao iguais                          
;       1 -> Diferentes                                  
;(char *string1[RDI], char *string2[RSI], int num_bytes[RDX])
; int cmp_str(char *string1, char *string2, int num_bytes)
cmp_str:			mov  rcx, rdx
				test rcx, rcx
				jz   .Testar_zero
.Volta:				lodsb
				cmp  al, [rdi]
				jne  .Trocar
.Incrementar:			inc  rdi
				loop .Volta
				jmp  .Igual
.Trocar:			cmp  al, 65
				jb   .Dif
				xor  al, 32
				cmp  al, [rdi]
				je   .Incrementar
.Term:				test rcx, rcx
				jz   .Igual
.Dif:				mov  rax, 1
				ret
.Testar_zero:			mov  al, [rsi]
				cmp  al, [rdi]
				jne  .Dif
.Igual:				xor  rax, rax
				ret
;======================================================= 
; Funcao para comparar duas strings desconciderando      
; a diferena entre maisculas e minsculas sem          
; precisar especificar o tamanho de uma delas            
; Retornos:                                              
; RAX = 0 -> Strings sao iguais                          
;       1 -> Diferentes                                  
; (char *string1[RDI], char *string2[RSI])
; int cmp_str_vars(char *string1, char *string2)
cmp_str_vars:			dec  rdi
.Volta:				inc  rdi
				lodsb
				cmp  al, [rdi]
				jne  .Trocar
				test al, al
				jz   .Igual
				jmp  .Volta
.Trocar:			xor  al, 32
				cmp  al, [rdi]
				je   .Volta
				mov  rax, 1
				ret
.Igual:				xor  rax, rax
				ret
;======================================================= 
; Funcao para decodificar uma string em base64           
; Retornos:                                              
; RAX = Retorna o tamanho do novo buffer decodificado    
;(char *str_destino[RDI], char *str_base64[RSI])
;unsigned int base64_decod(char *str_destino, char *str_base64)
base64_decod:			push rdx
				push rcx
				mov  r10, rdi
				mov  rdi, rsi
				cld
				xor  eax, eax
				mov  rcx, 0FFFFFFFFFFFFFFFFh
				repne scasb
				dec  rdi
				mov  rcx, rdi
				sub  rcx, rsi
				cmp  rcx, 4
				jb   .Base_invalida
				shr  rcx, 2             ; Dividindo por 4
				mov  r11, rcx
				mov  rdi, r10
				add  rsi, 3
				std
				mov  rbx, base64_reversa
.Prox_casa:			lodsb                 ;                         
				xlatb                 ;  Esta parte podia ter   
				ror  eax, 6           ;  sido feita com loop,   
				lodsb                 ;  mas preferi assim para 
				xlatb                 ;  gastar menos proc.     
				ror  eax, 6           ;  por excluir o uso de   
				lodsb                 ;  loop, push e pop para  
				xlatb                 ;  salvar o valor de ecx  
				ror  eax, 6           ;                         
				lodsb                 ;                         
				xlatb                 ;                         
				ror  eax, 6           ;                         
				xchg al, ah
				ror  eax, 16
				xchg al, ah
				mov  [rdi], eax
				add  rdi, 3
				add  rsi, 8
				loop .Prox_casa
				sub  rsi, 4
				xor  rcx, rcx
.Acha_fim:			cmp  [rsi], byte '='
				jne  .Fim
				dec  rsi
				dec  rdi
				inc  rcx
				jmp  .Acha_fim
.Fim:				mov  [rdi], byte 0
				mov  rax, r11
				mov  r11, 3
				mul  r11
				sub  rax, rcx
.Base_invalida:			cld
				pop  rcx
				pop  rdx
				ret
;======================================================= 
; Funcao para codificar uma string em base64             
; Retornos:                                              
; RAX = Retorna o tamanho do novo buffer codificado      
;(char *str_base64[RDI], char *str_texto[RSI], int tamanho[RDX])
;unsigned int base64_codify(char *str_base64, char *str_texto, int tamanho);
base64_cod:			push rbx
				push rcx
				mov  rax, rdx          ;Salvando tamanho da string
				xor  edx, edx
				mov  r10d, 3
				div  r10d
				mov  r10, rdi
				mov  ecx, eax          ;Zera os bits mais altos dos 64 bits de rcx
				mov  rbx, base64_tab
				std
				push dx
				test dl, dl
				jz   .Prox_bloco
				inc  rcx
.Prox_bloco:			mov  eax, [rsi]
				ror  ax, 8
				ror  eax, 16
				ror  ax, 8
				shr  eax, 6
				shr  al, 2
				add  rdi, 3
				xlatb
				stosb
				shr  eax, 6
				shr  al, 2
				xlatb
				stosb
				shr  eax, 6
				shr  al, 2
				xlatb
				stosb
				shr  eax, 6
				shr  al, 2
				xlatb
				stosb
				shr  eax, 6
				add  rdi, 5
				add  rsi, 3
				loop .Prox_bloco
				cld
				pop  dx
				test dl, dl
				jz   .Fim
				mov  rcx, 3
				sub  cl, dl
				sub  rdi, rcx
				mov  [rdi], byte '='
				dec  cl
				inc  rdi
				test cl, cl
				jz   .Fim
				mov  [rdi], byte '='
				inc  rdi
.Fim:				mov  [rdi], byte 0
				mov  rax, rdi
				sub  rax, r10
				mov  [rdi], byte 0
				pop  rcx
				pop  rbx
				ret
;======================================================= 
; Funcao para copiar os enderecos de email arrumando     
; caracteres invalidos                                   
; Retorno:                                               
; --> Numero de @ encontrados                            
;(char *destino[RDI], char *origem[RSI])
;unsigned int selor_segcp_min(char *destino, char *origem)
selor_segcp:			mov  r10, rbx
				mov  r11, rcx
				xor  rcx, rcx
				mov  rbx, base_val_email      ; Base contendo bytes validos
.Volta:				lodsb
				cmp  al, 'Z'
				ja   .Copiar
				cmp  al, 'A'
				jb   .Copiar
;				or   al, 100000b                  ; Convertendo para minusculo. Foi desativado para nao dar problema com o SRS
.Copiar:			stosb
				test al, al
				jz   .Fim
				cmp  al, '@'
				je   .Arroba
.Xlat:				xlatb
				test al, al
				jnz  .Volta
				dec  rdi
				jmp  .Volta
.Arroba:			inc  rcx
				jmp  .Xlat
.Fim:				mov  rax, rcx
				mov  rcx, r11
				mov  rbx, r10
				ret
;======================================================= 
; Procura por caracteres invalidos para previnir         
; Selor Script injection no 'helo'                       
; Retorno:                                               
;  0 = Str valida                                        
;  1 = Str invalida                                      
;(char *str[RDI])
;char t_inject(char *str)
t_inject_helo:			push rbx
				push rcx
				push rsi
				mov  rsi, rdi
				mov  rbx, base_val_helo
.Volta:				lodsb
				test al, al
				jz   .Ok
				xlatb
				test al, al
				jnz  .Volta
				mov  rax, 1
				jmp  .Fim
.Ok:				xor  eax, eax
.Fim:				pop  rsi
				pop  rcx
				pop  rbx
				ret
;======================================================= 
; Arruma o buffer recebido pelo cliente. O ENTER com     
; codigo 13,10 vai para 10 e o '\n..' vai para '\n.'     
; Retornos:                                              
; RAX -> Tamanho do novo buffer                          
; A variavel fim_header  alterada quando o fim do header
;  encontado. Ela retorna a posicao dele no buffer de   
; destino                                                
;(char *destino[RDI], char *origem[RSI], int num_bytes[RDX], char *ult_buffer[RCX], char **fim_header[R8]);
;int conv_crlf(char *destino, char *origem, int num_bytes, char *ult_buffer, char **fim_header);
conv_crlf:			xchg rcx, rdx          ;rdx=ult_buffer; rcx= num_bytes
				mov  r10, [r8]
				test r10, r10
				jz   .Header_n_detectado
				cmp  [rsi], byte '.'
				jne  .Inicio
				inc  rsi
				dec  rcx
				cmp  [rdx], word 2E0Ah ;2E0Ah = '\n.'
				je   .Inicio
				dec  rsi
				inc  rdx
				inc  rcx
				cmp  [rdx], byte 10
				jne  .Inicio
				inc  rsi
				dec  rcx
				cmp  [rsi], byte '.'
				je   .Inicio
				inc  rcx
				dec  rsi
.Inicio:			mov  rdx, rdi
.Prox_byte:			lodsb
				cmp  al, 13
				je   .Nao_copiar
				cmp  al, '.'
				je   .Ponto
.Copiar:			stosb
.Nao_copiar:			loop .Prox_byte
.Fim:				mov  rax, rdi
				sub  rax, rdx        ; Tam do buffer em EAX
				ret
.Ponto:				cmp  [rsi - 2], byte 10
				jne  .Copiar
				dec  rcx
				inc  rsi
				cmp  [rsi - 1], byte '.'
				je   .Copiar
				dec  rsi
				inc  rcx
				jmp  .Copiar
	; --------- Funcao duplicada com busca de fim de header --------- 
.Header_n_detectado:		cmp  [rsi], byte 10
				je   .Header_detect_inicio
				cmp  [rsi], word 2573 ; 2573 = \r\n
				je   .Header_detect_inicio
				cmp  [rsi], byte '.'
				jne  .Inicio2
				inc  rsi
				dec  rcx
				cmp  [rdx], word 2E0Ah ;2E0Ah = '\n.'
				je   .Inicio2
				dec  rsi
				inc  rdx
				inc  rcx
				cmp  [rdx], byte 10
				jne  .Inicio2
				inc  rsi
				dec  rcx
				cmp  [rsi], byte '.'
				je   .Inicio2
				inc  rcx
				dec  rsi
.Inicio2:			mov  rdx, rdi
.Prox_byte2:			lodsb
				cmp  al, 13
				je   .Nao_Copiar2
				cmp  al, '.'
				je   .Ponto2
				cmp  al, 10
				je   .Header_detect
.Copiar2:			stosb
.Nao_Copiar2:			loop .Prox_byte2
				jmp  .Fim
.Ponto2:			cmp  [rsi - 2], byte 10
				jne  .Copiar2
				dec  rcx
				inc  rsi
				cmp  [rsi - 1], byte '.'
				je   .Copiar2
				dec  rsi
				inc  rcx
				jmp  .Copiar2
.Header_detect_inicio:		inc  rdx
				cmp  [rdx], byte 10
				jne  .Inicio2
				mov  rdx, rdi
				lodsb
				mov  [r8], rdi
				jmp  .Copiar
.Header_detect:			cmp  [rdi - 1], byte 10
				jne  .Copiar2
				mov  [r8], rdi
				jmp  .Copiar
;======================================================= 
; Funcao para ler um buffer lido e separa-lo em linhas   
; Retornos:                                              
; RAX -> 0 = Linha pronta para ser lida                  
;        1 = Novo buffer  necessario                    
;(struct cpl_struct *[RDI])
;int cpl(struct cpl_struct *)
cpl:				mov  r10, rdi
				push rsi
				push rcx
				mov  rsi, [r10]      ; cpl_struct.orig 
				mov  rdi, [r10 + 8]  ; cpl_struct.dest 
				mov  ecx, [r10 + 16] ; cpl_struct.tamusado    - 'mov ecx' ja da um reset nos bits altos de rcx
				test ecx, ecx
				jz   .Arrumar
.Volta:				lodsb
				cmp  al, 10
				je   .Finalizar
				test al, al
				jz   .Zero
				cmp  al, 13
				je   .Pular_13
				stosb
.Pular_13:			loop .Volta
.Arrumar:			lodsb
				cmp  al, 10
				je   .Finalizar
				test al, al
				jnz  .Arrumar
.Zero:				mov  rax, 1
				jmp  .Fim
.Finalizar:			mov  ecx, [r10 + 20]  ; cpl_struct.tambuffer
				xor  rax, rax
.Fim:				mov  [r10], rsi
				mov  [rdi], byte 0    ;Finalizando a string com ZERO
				mov  [r10 + 8], rdi
				mov  [r10 + 16], ecx
				pop  rcx
				pop  rsi
				ret
;struct cpl_struct {
; unsigned int orig;
; unsigned int dest;
; unsinged int tamusado;
; unsigned int tambuffer;
;}
;======================================================= 
; Funcao para transformar um valor decimal (32 bits)para 
; o mesmo valor escrito em forma de texto	         
; Retonos:                                               
; EAX -> Ponteiro para a string convertida               
;(unsigned int valor[RSI], int num_casas[RSI])
;char *itoa(unsigned int valor, int num_casas);
itoa:				push rdx
				push rcx
				push rbx
				mov  rcx, TAM_str_itoa
				mov  r10d, edi
				mov  rdi, texto_itoa
				mov  al, '0'
				rep  stosb
				mov  eax, r10d
				cmp  eax, 10
				jb   .Ult_carac
				mov  ebx, 10
.Prox:				xor  edx, edx
				div  ebx
				add  dl, 48
				dec  rdi
				mov  [rdi], dl
				cmp  eax, 10
				jae  .Prox
.Ult_carac:			add  al, 48
				dec  rdi
				mov  [rdi], al
				and  rsi, 0Fh        ; Maximo de 15 zeros possiveis 
				mov  rax, texto_itoa + TAM_str_itoa
				sub  rax, rsi
				cmp  rax, rdi
				jb   .Fim
				mov  rax, rdi
.Fim:				pop  rbx
				pop  rcx
				pop  rdx
				ret
;======================================================= 
; Funcao para testar se um IP esta contido em uma rede   
; Retornos:                                              
; EAX = 0 -> Nao esta contido                            
;     = 1 -> Esta contido                                
;(unsigned int ip[RDI], unsigned int rede[RSI], unsigned short mascara[RDX]);
;char tmasc(unsigned int ip, unsigned int rede, unsigned short mascara);
tmasc:				push cx
				cmp  dx, 32
				ja   .Diferente
				mov  cx, 32
				sub  cx, dx
				test cx, cx
				jz   .Comparar
				ror  di, 8
				ror  edi, 16
				ror  di, 8
				ror  si, 8
				ror  esi, 16
				ror  si, 8
				shr  edi, cl
				shr  esi, cl
.Comparar:			cmp  edi, esi
				je   .Igual
.Diferente:			xor  rax, rax
				pop  cx
				ret
.Igual:				mov  eax, 1    ;Define 1 em todo o RAX
				pop  cx
				ret
;======================================================= 
; Funcao para varrer um vetor a procura de um possivel   
; ataque DoS                                             
; Retornos:                                              
; EAX = 0 -> Nada detectado                              
;       1 -> Possivel ataque DoS detectado               
;(struct str_dosd *)[RDI]
;char dosd(struct str_dosd *)
dosd:				mov  r10, rdi
				push rsi
				push rbx
				push rcx
				xor  ecx, ecx
				xor  r11d, r11d
				mov  eax, [DOSD_timestamp]
				mov  rdi, [DOSD_atual_posi]
				mov  [rdi + 4], eax
				mov  eax, [DOSD_ip]
				mov  [rdi], eax
				mov  rsi, [DOSD_fim_mem]
.Volta_01:			add  rdi, 8
				cmp  rdi, rsi
				jae  .Ver_outro_lado
				cmp  eax, [rdi]
				jne  .Volta_01
				mov  ebx, [rdi + 4]
				sub  ebx, ecx
				mov  ecx, [rdi + 4]
				cmp  ebx, [DOSD_intervalo]
				ja   .Volta_01
				inc  r11d
				jmp  .Volta_01
.Ver_outro_lado:		mov  rsi, [DOSD_atual_posi]
				mov  rdi, [DOSD_mem]
.Volta_02:			cmp  eax, [rdi]
				je   .Computar
.Checar_final:			add  rdi, 8
				cmp  rdi, rsi
				jbe  .Volta_02
				xor  eax, eax
				cmp  r11d, [DOSD_num_ocorr]
				jb   .Finalizar
				inc  eax
.Finalizar:			mov  rsi, [DOSD_fim_mem]
				sub  rsi, 8
				cmp  rsi, [DOSD_atual_posi]
				ja   .Adicionar
				mov  rsi, [DOSD_mem]
				mov  [DOSD_atual_posi], rsi
				jmp  .Final
.Adicionar:			add  [DOSD_atual_posi], dword 8
.Final:				pop  rcx
				pop  rbx
				pop  rsi
				ret
.Computar:			mov  ebx, [rdi + 4]
				sub  ebx, ecx
				mov  ecx, [rdi + 4]
				cmp  ebx, [DOSD_intervalo]
				ja   .Checar_final
				inc  r11d
				jmp  .Checar_final
;struct str_dosd {            
; unsigned int ip             
; unsigned int timestamp      
; char *mem                   
; char *fim_mem               
; char *atual_posi            
; unsigned int intervalo      
; unsigned int num_ocorrencias
;}                          
;======================================================= 



